﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.DirectX.DirectInput;
using System.Threading;

namespace WindowsFormsApplication1
{
    public partial class padScan : Form
    {
        Device joyStick;
        bool buttonClicked = false;
        int num_of_button = 0;

        public padScan()
        {
            InitializeComponent();
        }


        private void padScan_Load(object sender, EventArgs e)
        {
            joyPadClass joypadC = new joyPadClass();

            joyStick = joypadC.getJoyPad(padSetting.PadInstance.selectedJoyStick, this.Handle);

            // デバイスに対するアクセス権をとる
            if (joyStick != null)
            {
                joyStick.Acquire();
                num_of_button = joyStick.Caps.NumberButtons;
            }

        }


        private void padScan_Shown(object sender, EventArgs e)
        {

            Thread thKey = new Thread(delegate()
            {
                padSetting.PadInstance.scannedKey = keyWait();  // キー入力を待つ
            });
            thKey.Start();

            while (buttonClicked == false)
            {
                Thread.Sleep(25);  // ボタン
                Application.DoEvents();
            }

            Thread.Sleep(500);
            this.Dispose();

        }


        private int keyWait() { // パッドのキー入力待ち(ボタン
            int result=-1;

            while (buttonClicked == false) {    // パッドの入力待ち

                // コントローラの状態をポーリングで取得
                joyStick.Poll();
                JoystickState state = joyStick.CurrentJoystickState;

                // 1ボタンを押している間は加速する
                if (num_of_button != 0)
                {
                    for (int i = 0; i < num_of_button; i++)
                    {
                        byte button = state.GetButtons()[i];
                        System.Diagnostics.Debug.WriteLine(button.ToString());
                        if (button == joyPadClass.PAD_BUTTON_PUSHED)
                        {
                            result = i;
                            buttonClicked = true;
                        }
                    }
                }
                Thread.Sleep(33);
            }
            
            return result;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            buttonClicked = true;
        }





    }
}
